/******************************************************************************
 *
 *	Papillon
 *	color edition
 *	PalmOS5
 *	ver 1.1.0
 *	2008.04
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	XN[̏
 ***********************************************/
Err
init_screen( void )
{
  UInt16 error;
  UInt32 width = 160, height = 160, depth = 8;
  Boolean color;


  // J[T|[gĂ邩
  WinScreenMode( winScreenModeGet, NULL, NULL, NULL, &color );
  if( ! color )
    return -1;

  WinScreenMode( winScreenModeGet,
                 &Screen.save.width,
                 &Screen.save.height,
                 &Screen.save.depth,
                 NULL );
  WinScreenMode( winScreenModeSet, &width, &height, &depth, NULL );

  // obNXN[쐬
  Screen.back_h = WinCreateOffscreenWindow( BACK_WIDTH, BACK_HEIGHT+BACK_BTM_BLANK,
                                            screenFormat, &error );
  ErrFatalDisplayIf( error, "Error Allocating Offscreen" );

  // XN[NA
  clear_screen();

  return errNone;
}



/************************************************
 *	obNXN[LCDɃRs[
 ***********************************************/
void
copy_buff_to_lcd( void )
{
  RectangleType r;


  r.topLeft.x = 16, r.topLeft.y = 16, r.extent.x = 160, r.extent.y = 160;
  WinCopyRectangle( Screen.back_h, NULL, &r, 0, 0, winPaint );
}



/************************************************
 *	SʃNA
 ***********************************************/
void
clear_screen( void )
{
  WinSetDrawWindow( Screen.back_h );
  WinPushDrawState();
  WinSetBackColor( INDEX_WHITE );

  WinEraseWindow();

  WinPopDrawState();
  WinSetDrawWindow( NULL );
}



/************************************************
 *	BG`
 ***********************************************/
void
draw_bg( void )
{
  RectangleType r;


  r.topLeft.x = 0, r.topLeft.y = 0, r.extent.x = 160, r.extent.y = 160;
  WinCopyRectangle( Bg.handle, Screen.back_h, &r, 16, 16, winPaint );
}



/************************************************
 *	XvCg\iobNXN[j
 *	n*nhbg 8bit XvCg
 ***********************************************/
void
sprite( Coord x, Coord y, WinHandle chr_no )
{
  RectangleType r;


  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  WinGetBounds( chr_no, &r );

  WinCopyRectangle( chr_no, Screen.back_h, &r, x, y, winPaint );
}



/************************************************
 *	LINEiobNXN[j
 ***********************************************/
void
line( Coord x0, Coord y0, Coord x1, Coord y1, IndexedColorType col, PsetWidthType size )
{
  // ͈̓`FbN
/*  if( (UInt16) x0 >= 160+BACK_W_BLANK
      || (UInt16) x1 >= 160+BACK_W_BLANK
      || (UInt16) y0 >= 160+BACK_H_BLANK
      || (UInt16) y1 >= 160+BACK_H_BLANK )
    return;
*/
  WinSetDrawWindow( Screen.back_h );
  WinPushDrawState();
  WinSetForeColor( col );

  WinDrawLine( x0, y0, x1, y1 );
  if( size == bold )
    {
      WinDrawLine( x0-1, y0, x1-1, y1 );
      WinDrawLine( x0, y0-1, x1, y1-1 );
    }

  WinPopDrawState();
  WinSetDrawWindow( NULL );
}



///////////////////////////////////////////////////////////////////////////////
