/******************************************************************************
 *
 *	Papillon
 *	color edition
 *	PalmOS5
 *	ver 1.1.0
 *	2008.04
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/

// ʉf[^
// [D揇] [f[^] [ms] [gHz], [t[] JԂ
static const int se_data[ sound_cnt ][ SND_LENGTH ] =
{
  { 0 }	,									// no_sound
  { 1, 2, 38, 349, 392 },							// down	: F/G
  { 2, 1, 20, 220 },								// new	: A
  { 3, 6, 38, 311, 311, 311, 277, 277, 277 },					// miss	: D#/C#
  { 4, 9, 38, 523, 523, 523, 659, 659, 659, 784, 784, 784 },			// hit	: C/E/G
  { 5, 6, 38, 587, 587, 587, 659, 659, 659 },					// item	: D/E
  { 6, 12, 38, 523, 523, 523, 659, 659, 659, 784, 784, 784, 988, 988, 988 },	// bonus: C/E/G/B
  { 7, 6, 20, 196, 196, 196, 196, 196, 196 },					// obstacle: G
  { 8, 6, 20, 440, 440, 440, 440, 440, 440 },					// rewound: A
  { 9, 12, 38, 415, 415, 415, 392, 392, 392, 349, 349, 349, 311, 311, 311 },	// game_over: Ab/G/F/Eb
  { 10,15, 38, 494, 494, 494, 622, 622, 622, 554, 554, 554, 740, 740, 740, 622, 622, 622 }, 		// game_clear : B/D#/C#/F#//D#
  { 100, 1, 38, 440 },								// click: A
};



/************************************************
 *	SEIIt؂芷
 ***********************************************/
void
change_se( void )
{
  if( Key.keep == KEY_DOWN )
    {
      Sound.on ^= 1;
      set_se( click );
    }
}



/************************************************
 *	ʉZbg
 ***********************************************/
void
set_se( SoundType type )
{
  if( se_data[ type ][0] >= se_data[ Sound.type ][0] )
    {
      Sound.type = type;
      Sound.repeat = 0;
    }
}



/************************************************
 *	ʉ
 ***********************************************/
void
sound( void )
{
  SndCommandType cmd;


  if( Sound.type != no_sound && Sound.on )
    {
      cmd.cmd = sndCmdFrqOn;
      cmd.param1 = se_data[ Sound.type ][ 3 + Sound.repeat ];
      cmd.param2 = se_data[ Sound.type ][2];
      cmd.param3 = Sound.volume;

      SndDoCmd( NULL, &cmd, true );

      if( ++Sound.repeat >= se_data[ Sound.type ][ 1 ] )
        Sound.type = no_sound;
    }
}



